Subject: Re: [PATCH net] l2tp: pass correct message length to ip6_append_data

From: Simon Horman <[email-masked]>
Date: Wed, 21 Feb 2024 14:43:16 +0000

On Tue, Feb 20, 2024 at 12:21:56PM +0000, Tom Parkin wrote:
> l2tp_ip6_sendmsg needs to avoid accounting for the transport header
> twice when splicing more data into an already partially-occupied skbuff.
> 
> To manage this, we check whether the skbuff contains data using
> skb_queue_empty when deciding how much data to append using
> ip6_append_data.
> 
> However, the code which performed the calculation was incorrect:
> 
>      ulen = len + skb_queue_empty(&sk->sk_write_queue) ? transhdrlen : 0;
> 
> ...due to C operator precedence, this ends up setting ulen to
> transhdrlen for messages with a non-zero length, which results in
> corrupted packets on the wire.
> 
> Add parentheses to correct the calculation in line with the original
> intent.
> 
> Fixes: 9d4c75800f61 ("ipv4, ipv6: Fix handling of transhdrlen in __ip{,6}_append_data()")
> Cc: David Howells <[email-masked]>
> Cc: [email-masked]
> Signed-off-by: Tom Parkin <[email-masked]>

Reviewed-by: Simon Horman <[email-masked]>

> ---
> This issue was uncovered by Debian build-testing for the
> golang-github-katalix-go-l2tp package[1].
> 
> It seems 9d4c75800f61 has been backported to the linux-6.1.y stable
> kernel (and possibly others), so I think this fix will also need
> backporting.
> 
> The bug is currently seen on at least Debian Bookworm, Ubuntu Jammy, and 
> Debian testing/unstable.

In that case perhaps this is appropriate - citing the patch that 9d4c75800f61
tried to fix?

	Fixes: a32e0eec7042 ("l2tp: introduce L2TPv3 IP encapsulation support for IPv6")

> 
> Unfortunately tests using "ip l2tp" and which focus on dataplane
> transport will not uncover this bug: it's necessary to send a packet
> using an L2TPIP6 socket opened by userspace, and to verify the packet on
> the wire.  The l2tp-ktest[2] test suite has been extended to cover this.
> 
> [1]. https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1063746
> [2]. https://github.com/katalix/l2tp-ktest

...